package cse403.java;

import java.util.ArrayList;

public class Celsius implements Subject
{
    private double degrees;

    public Celsius(double aDegrees)
    {
        degrees = aDegrees;
    }

    public double getDegrees()
    {
        return degrees;
    }

    public void setDegrees(double aDegrees)
    {
        degrees = aDegrees;
        stateChanges();
    }

    /*
     * These are the code that was in aspects.
     */
    private ArrayList <Observer> observers = new ArrayList <Observer>();
    
    @Override
    public void addObserver(Observer observer)
    {
        observers.add(observer);
        observer.setSubject(this);
    }

    @Override
    public void remove(Observer observer)
    {
        observers.remove(observer);
        observer.setSubject(null);
    }

    @Override
    public ArrayList <Observer> getObservers()
    {
        return observers;
    }

    @Override
    public Object getData()
    {
        return degrees;
    }
    
    private void stateChanges()
    {
        for (Observer observer: observers)
            observer.update();
    }
}
