package cse403.observer;

import cse403.aop.Celsius;
import cse403.aop.Thermometer;

public aspect ObserverPatternImpl extends ObserverPattern
{
    /*
     * Code belonging to an implementation of a subject (Celsius)
     */
    declare parents: Celsius implements Subject;

    public Object Celsius.getData()
    {
        return this;
    }

    /*
     * Code belonging to an implementation of an Observer (thermometer)
     */
    declare parents: Thermometer implements Observer;

    public void Thermometer.update()
    {
        drawTemperature();
    }

    /*
     * Code telling what to do.
     */
    pointcut stateChanges(Subject subject): target(subject) && call(void Celsius.setDegrees(..));
}
